/* pmudmon applet
 *** Copyright (C) 2000 Mike Palczewski mpalczew@u.washington.edu
 *** 
 *** This program is free software; you can redistribute it and/or
 *** modify it under the terms of the GNU General Public License
 *** as published by the Free Software Foundation; either version 2
 *** of the License, or (at your option) any later version.
 *** 
 *** This program is distributed in the hope that it will be useful,
 *** but WITHOUT ANY WARRANTY; without even the implied warranty of
 *** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *** GNU General Public License for more details.
 *** 
 *** You should have received a copy of the GNU General Public License
 *** along with this program; if not, write to the Free Software
 *** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  
 *** 02111-1307, USA.
 ***/

#include "conf.h"
#include "main.h"

conf* get_conf() {
	conf* l;
	l=g_malloc(sizeof(conf));
	
	l->height=gnome_config_get_int("/pmudmon/main/height=24");
	l->width=gnome_config_get_int("/pmudmon/main/width=150");
	l->time=gnome_config_get_int("/pmudmon/main/time=10");
	l->orientation=gnome_config_get_int("/pmudmon/main/orientation=0");
	l->format_charging=gnome_config_get_string("/pmudmon/main/charging=AC Charging%p%%");
	l->format_battery=gnome_config_get_string("/pmudmon/main/battery=Battery %p%%");
	l->format_charged=gnome_config_get_string("/pmudmon/main/charged=AC Charged %p%%");
	l->shutdown=gnome_config_get_int("/pmudmon/main/shutdown=0");
	
	/*default background white*/
	l->bg_red=gnome_config_get_int("/pmudmon/bg/red=65535");
	l->bg_green=gnome_config_get_int("/pmudmon/bg/green=65535");
	l->bg_blue=gnome_config_get_int("/pmudmon/bg/blue=65535");

	/*default charging color green*/
	l->ca_red=gnome_config_get_int("/pmudmon/charging/red=0");
	l->ca_green=gnome_config_get_int("/pmudmon/charging/green=65535");
	l->ca_blue=gnome_config_get_int("/pmudmon/charging/blue=0");

	/*default charged color blue*/
	l->cd_red=gnome_config_get_int("/pmudmon/charged/red=0");
	l->cd_green=gnome_config_get_int("/pmudmon/charged/green=0");
	l->cd_blue=gnome_config_get_int("/pmudmon/charged/blue=65535");

	/*default battery color red*/
	l->bt_red=gnome_config_get_int("/pmudmon/battery/red=65535");
	l->bt_green=gnome_config_get_int("/pmudmon/battery/green=0");
	l->bt_blue=gnome_config_get_int("/pmudmon/battery/blue=0");

	return l;
}



void set_conf(conf* config) {
	gnome_config_set_int("/pmudmon/main/height",config->height);
	gnome_config_set_int("/pmudmon/main/width",config->width);
	gnome_config_set_int("/pmudmon/main/orientation",config->orientation);
	gnome_config_set_int("/pmudmon/main/time",config->time);
	
	if (config->format_charging)
		gnome_config_set_string("/pmudmon/main/charging",config->format_charging);
	if (config->format_battery)
		gnome_config_set_string("/pmudmon/main/battery",config->format_battery);
	if (config->format_charged)
		gnome_config_set_string("/pmudmon/main/charged",config->format_charged);
	gnome_config_set_int("/pmudmon/main/shutdown",config->shutdown);

	gnome_config_set_int("/pmudmon/bg/red",config->bg_red);
	gnome_config_set_int("/pmudmon/bg/green",config->bg_green);
	gnome_config_set_int("/pmudmon/bg/blue",config->bg_blue);

	gnome_config_set_int("/pmudmon/charging/red",config->ca_red);
	gnome_config_set_int("/pmudmon/charging/green",config->ca_green);
	gnome_config_set_int("/pmudmon/charging/blue",config->ca_blue);

	gnome_config_set_int("/pmudmon/charged/red",config->cd_red);
	gnome_config_set_int("/pmudmon/charged/green",config->cd_green);
	gnome_config_set_int("/pmudmon/charged/blue",config->cd_blue);

	gnome_config_set_int("/pmudmon/battery/red",config->bt_red);
	gnome_config_set_int("/pmudmon/battery/green",config->bt_green);
	gnome_config_set_int("/pmudmon/battery/blue",config->bt_blue);

	
	gnome_config_sync();
}


void free_conf(conf* config) {
	if (config->format_charging)
		g_free(config->format_charging);
	if (config->format_battery)
		g_free(config->format_battery);
	if (config->format_charged)
		g_free(config->format_charged);
	g_free(config);
}
